require 'mail'
require 'securerandom'

DataCommand = Struct.new(:session, :body) do
  def call
    if session.reverse_path and session.forward_path
      session.connection.puts session.reply(354)

      while line = session.connection.gets and not line =~ /^(\r\n)?\.\r\n$/
        puts "Recieved #{line}"
        session.message.push(line)
      end

      mail = Mail.new(session.message.join)

      puts "writing to #{mail.to.last}/#{mail.message_id}.eml"
      # this could be dangerous as fake messages could flood in
      # as we would just be committing them all to disk. Should do this
      # async?
      File.open("./#{mail.to.last}/#{mail.message_id}.eml", 'w') do |f|
        f.write(mail)
      end

      session.reply(250)
    else
      session.reply(451)
    end
  end
end
