RecipientCommand = Struct.new(:session, :body) do
  def call
    # RCPT <SP> TO:<forward-path> <CRLF>
    return session.reply(451) unless session.reverse_path

    forward_path = /TO:<(.+)>/.match(body)[1]
    return session.reply(501) unless forward_path
    return session.reply(551, forward_path) unless Dir.
      exists?("./#{forward_path}")

    session.forward_path = forward_path
    session.reply(250, 'added recipient')
  end
end
